#include <stdio.h>
#include <mpi.h>

void main(int argc, char *argv[]) {
	
	int myrank, size;
	int a;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank); /* Get my rank */
	MPI_Comm_size(MPI_COMM_WORLD, &size); /* Get the total number of processors */
			
	if (myrank==0) { /* processo 0*/
		a = size;
		MPI_Send(&a, 1, MPI_INT, 1, 17, MPI_COMM_WORLD);
		printf("Sono il processo %d e ho inviato %d al processo %d.\n", myrank, a, myrank + 1);
		MPI_Recv(&a, 1, MPI_INT, (size - 1), 17, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		printf("Sono il processo %d e ho ricevuto %d dal processo %d.\n", myrank, a, size - 1);
	}
	else if (myrank==(size-1)) { /* processo N-1 (ultimo)*/
		MPI_Recv(&a, 1, MPI_INT, myrank - 1, 17, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		printf("Sono il processo %d e ho ricevuto %d dal processo %d.\n", myrank, a, myrank - 1);
		a--;
		MPI_Send(&a, 1, MPI_INT, 0, 17, MPI_COMM_WORLD);
		printf("Sono il processo %d e ho inviato %d al processo %d.\n", myrank, a, 0);
	}
	else { /* processo i*/
		MPI_Recv(&a, 1, MPI_INT, myrank - 1, 17, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		printf("Sono il processo %d e ho ricevuto %d dal processo %d.\n", myrank, a, myrank - 1);
		a--;
		MPI_Send(&a, 1, MPI_INT, myrank + 1, 17, MPI_COMM_WORLD);
		printf("Sono il processo %d e ho inviato %d al processo %d.\n", myrank, a, myrank + 1);
	}
			
	MPI_Finalize();
}